import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

public class Sierpinski extends Applet implements MouseListener
{
  public static final long serialVersionUID = 1L; // gets rid of an annoying warning

  int maxLevel = 7;
  int level = 1;
  int x1=0, y1=0, x2=0, y2=0, x3=0, y3=0;
  boolean mouseIn = false;

  public void init()
  {
    maxLevel = Integer.parseInt( getParameter( "maxLevel" ) );
    x1 = Integer.parseInt( getParameter( "x1" ) );
    y1 = Integer.parseInt( getParameter( "y1" ) );
    x2 = Integer.parseInt( getParameter( "x2" ) );
    y2 = Integer.parseInt( getParameter( "y2" ) );
    x3 = Integer.parseInt( getParameter( "x3" ) );
    y3 = Integer.parseInt( getParameter( "y3" ) );

    setBackground(Color.white);
    this.addMouseListener(this);
  }//init()

  public void paint(Graphics g)
  {
/*  // draw a border in black
    Dimension dim = getSize();
    g.setColor(Color.black);
    g.drawLine(0, 0, dim.width-1, 0);
    g.drawLine(dim.width-1, 0, dim.width-1, dim.height-1);
    g.drawLine(dim.width-1, dim.height-1, 0, dim.height-1);
    g.drawLine(0, dim.height-1, 0, 0);
*/
    if (mouseIn)
      g.setColor(Color.red);
    else
      g.setColor(Color.blue);

    drawSierpinski(x1, y1, x2, y2, x3, y3, level, g);

  }//paint()

  public void drawSierpinski(int x1, int y1,
                             int x2, int y2,
                             int x3, int y3, int drawingLevel, Graphics g)
  {
    g.drawLine(x1, y1, x2, y2);
    g.drawLine(x2, y2, x3, y3);
    g.drawLine(x3, y3, x1, y1);
    drawingLevel--;
    if (drawingLevel > 0)
    {
      int x4 = (x1+x2)/2;
      int y4 = (y1+y2)/2;
      int x5 = (x2+x3)/2;
      int y5 = (y2+y3)/2;
      int x6 = (x3+x1)/2;
      int y6 = (y3+y1)/2;
      drawSierpinski(x1, y1, x4, y4, x6, y6, drawingLevel, g);
      drawSierpinski(x2, y2, x4, y4, x5, y5, drawingLevel, g);
      drawSierpinski(x3, y3, x5, y5, x6, y6, drawingLevel, g);
    }
  }//drawSierpinski()


  // The next five methods implement the MouseListener interface.
  public void mouseClicked( MouseEvent evnt)
  {
    level++;
    if (level > maxLevel) level = 1;
    repaint();
  }

  public void mouseReleased(MouseEvent e)
  {
  }

  public void mousePressed(MouseEvent e)
  {
  }

  public void mouseEntered(MouseEvent e)
  { mouseIn = true;
    repaint();
  }

  public void mouseExited(MouseEvent e)
  { mouseIn = false;
    repaint();
  }
}//Sierpinsky